'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapDispatchToProps = exports.mapStateToProps = exports.Dashboard = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _renderActions = require('../../actions/renderActions');

var _Logout = require('../Logout/Logout');

var _Logout2 = _interopRequireDefault(_Logout);

var _Issues = require('../Issues/Issues');

var _Issues2 = _interopRequireDefault(_Issues);

var _PrTable = require('../PrTable/PrTable');

var _PrTable2 = _interopRequireDefault(_PrTable);

var _Milestones = require('../Milestones/Milestones');

var _Milestones2 = _interopRequireDefault(_Milestones);

var _utils = require('../../utils/utils');

var _utils2 = _interopRequireDefault(_utils);

require('./Dashboard.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/no-named-as-default, no-shadow, consistent-return */
var Dashboard = exports.Dashboard = function Dashboard(_ref) {
  var repoName = _ref.repoName,
      displayRepos = _ref.displayRepos,
      orgName = _ref.orgName;
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _semanticUiReact.Menu,
      { compact: true },
      _react2.default.createElement(
        _semanticUiReact.Menu.Item,
        null,
        _react2.default.createElement(
          _semanticUiReact.Button,
          { icon: true, onClick: function onClick() {
              return displayRepos(orgName);
            } },
          _react2.default.createElement(_semanticUiReact.Icon, { name: 'arrow left' })
        )
      ),
      _react2.default.createElement(
        _semanticUiReact.Menu.Item,
        null,
        _react2.default.createElement(_Logout2.default, null)
      )
    ),
    _react2.default.createElement(
      _semanticUiReact.Container,
      null,
      _react2.default.createElement(
        _semanticUiReact.Grid,
        { padded: true },
        _react2.default.createElement(
          _semanticUiReact.Header,
          { as: 'h2', icon: true, textAlign: 'center' },
          _react2.default.createElement(_semanticUiReact.Icon, { name: 'github' }),
          _react2.default.createElement(
            _semanticUiReact.Header.Content,
            null,
            repoName
          )
        ),
        _react2.default.createElement(
          _semanticUiReact.Grid.Row,
          { columns: 3 },
          _react2.default.createElement(
            _semanticUiReact.Grid.Column,
            null,
            _react2.default.createElement(_PrTable2.default, { repoName: repoName })
          ),
          _react2.default.createElement(
            _semanticUiReact.Grid.Column,
            null,
            _react2.default.createElement(_Issues2.default, { repoName: repoName })
          ),
          _react2.default.createElement(
            _semanticUiReact.Grid.Column,
            null,
            _react2.default.createElement(_Milestones2.default, { repoName: repoName })
          )
        )
      )
    )
  );
};

Dashboard.propTypes = {
  repoName: _propTypes2.default.string,
  displayRepos: _propTypes2.default.func.isRequired,
  orgName: _propTypes2.default.string
};

Dashboard.defaultProps = {
  repoName: null,
  orgName: null
};

var mapStateToProps = exports.mapStateToProps = function mapStateToProps(state, ownProps) {
  var id = ownProps.widgetId;
  var repoName = state.widgets.byId[id].currentPage.repoName;
  var orgName = state.widgets.byId[id].currentPage.selectedOrgName;

  return {
    repoName: repoName,
    orgName: orgName
  };
};

var mapDispatchToProps = exports.mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return (0, _redux.bindActionCreators)({
    displayRepos: _renderActions.displayRepos
  }, dispatch);
};

exports.default = (0, _utils2.default)((0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Dashboard));