'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapStateToProps = exports.PrTableRow = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _reactRedux = require('react-redux');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _utils = require('../../utils/utils');

var _utils2 = _interopRequireDefault(_utils);

require('./PrTableRow.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var merge = {
  color: 'red',
  position: 'absolute',
  top: '0',
  right: '0'
};

var getMergeable = function getMergeable(able) {
  if (able) {
    return _react2.default.createElement('div', null);
  } else if (able === false) {
    return _react2.default.createElement(_semanticUiReact.Icon, { style: merge, name: 'remove', size: 'big' });
  }
  return _react2.default.createElement('div', null);
};

var PrTableRow = exports.PrTableRow = function PrTableRow(_ref) {
  var created = _ref.created,
      mergeable = _ref.mergeable,
      submittedBy = _ref.submittedBy,
      title = _ref.title;

  var styles = {
    borderTop: '0.25px solid black'
  };

  var space = {
    position: 'relative',
    paddingTop: '4px',
    paddingBottom: '4px',
    fontSize: '16px'
  };

  return _react2.default.createElement(
    _semanticUiReact.Card.Content,
    { style: styles },
    _react2.default.createElement(
      _semanticUiReact.List,
      { divided: true, relaxed: true },
      _react2.default.createElement(
        _semanticUiReact.List.Item,
        null,
        _react2.default.createElement(
          _semanticUiReact.List.Content,
          { className: 'ui center aligned' },
          _react2.default.createElement(
            _semanticUiReact.List.Header,
            { style: space },
            title
          ),
          _react2.default.createElement(
            _semanticUiReact.List.Description,
            { style: space },
            'date created:',
            _react2.default.createElement(
              _semanticUiReact.Header,
              { sub: true },
              (0, _moment2.default)(created).fromNow()
            )
          ),
          _react2.default.createElement(
            _semanticUiReact.List.Description,
            { style: space },
            'submitted by:',
            _react2.default.createElement(
              _semanticUiReact.Header,
              { sub: true },
              submittedBy
            ),
            getMergeable(mergeable)
          )
        )
      )
    )
  );
};

PrTableRow.propTypes = {
  created: _propTypes2.default.string.isRequired,
  mergeable: _propTypes2.default.bool,
  submittedBy: _propTypes2.default.string.isRequired,
  title: _propTypes2.default.string.isRequired
};

PrTableRow.defaultProps = {
  mergeable: undefined
};

var mapStateToProps = exports.mapStateToProps = function mapStateToProps(state, ownProps) {
  var id = ownProps.widgetId;
  var prId = ownProps.prId;
  var pr = state.widgets.byId[id].pullRequests.prsById[prId];
  var created = pr.created,
      mergeable = pr.mergeable,
      submittedBy = pr.submittedBy,
      title = pr.title;

  return {
    created: created,
    mergeable: mergeable,
    submittedBy: submittedBy,
    title: title
  };
};

exports.default = (0, _utils2.default)((0, _reactRedux.connect)(mapStateToProps)(PrTableRow));