'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapDispatchToProps = exports.mapStateToProps = exports.RepoList = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _repoActions = require('../../actions/repoActions');

var _renderActions = require('../../actions/renderActions');

var _Repo = require('../Repo/Repo');

var _Repo2 = _interopRequireDefault(_Repo);

var _Logout = require('../Logout/Logout');

var _Logout2 = _interopRequireDefault(_Logout);

var _utils = require('../../utils/utils');

var _utils2 = _interopRequireDefault(_utils);

require('./RepoList.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable import/no-named-as-default, consistent-return */


function repoComponents(repos, org) {
  if (repos && repos[org]) {
    return repos[org].map(function (id) {
      return _react2.default.createElement(_Repo2.default, { key: id, repoId: id });
    });
  }
  return '';
}

var RepoList = exports.RepoList = function (_Component) {
  _inherits(RepoList, _Component);

  function RepoList() {
    _classCallCheck(this, RepoList);

    return _possibleConstructorReturn(this, (RepoList.__proto__ || Object.getPrototypeOf(RepoList)).apply(this, arguments));
  }

  _createClass(RepoList, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.props.retrieveRepos(this.props.userName, this.props.orgName);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _semanticUiReact.Menu,
          { compact: true },
          _react2.default.createElement(
            _semanticUiReact.Menu.Item,
            null,
            _react2.default.createElement(
              _semanticUiReact.Button,
              { icon: true, onClick: function onClick() {
                  return _this2.props.displayOrgs(_this2.props.userName);
                } },
              _react2.default.createElement(_semanticUiReact.Icon, { name: 'arrow left' })
            )
          ),
          _react2.default.createElement(
            _semanticUiReact.Menu.Item,
            null,
            _react2.default.createElement(_Logout2.default, null)
          )
        ),
        _react2.default.createElement(
          _semanticUiReact.Grid,
          { centered: true, padded: true },
          _react2.default.createElement(
            _semanticUiReact.Grid.Row,
            { width: 16 },
            _react2.default.createElement(
              _semanticUiReact.Header,
              { as: 'h2', icon: true, textAlign: 'center' },
              _react2.default.createElement(_semanticUiReact.Icon, { name: 'github' }),
              _react2.default.createElement(
                _semanticUiReact.Header.Content,
                null,
                'Which repository are you interested in?'
              )
            )
          ),
          _react2.default.createElement(
            _semanticUiReact.Grid.Row,
            { width: 16 },
            _react2.default.createElement(
              _semanticUiReact.List,
              { id: 'repo-list', animated: true, divided: true, horizontal: true, selection: true, size: 'huge' },
              repoComponents(this.props.reposByOrg, this.props.orgName)
            )
          )
        )
      );
    }
  }]);

  return RepoList;
}(_react.Component);

RepoList.propTypes = {
  retrieveRepos: _propTypes2.default.func.isRequired,
  displayOrgs: _propTypes2.default.func.isRequired,
  userName: _propTypes2.default.string.isRequired,
  orgName: _propTypes2.default.string.isRequired,
  reposByOrg: _propTypes2.default.objectOf(_propTypes2.default.array)
};

RepoList.defaultProps = {
  reposByOrg: {}
};

var mapStateToProps = exports.mapStateToProps = function mapStateToProps(state, ownProps) {
  var id = ownProps.widgetId;
  var reposByOrg = state.widgets.byId[id].repos.reposByOrg;
  var repoIds = state.widgets.byId[id].repos.ids;
  var reposById = state.widgets.byId[id].repos.reposById;
  var userName = state.widgets.byId[id].currentPage.userName;
  var orgName = state.widgets.byId[id].currentPage.selectedOrgName;

  return {
    reposByOrg: reposByOrg,
    repoIds: repoIds,
    reposById: reposById,
    userName: userName,
    orgName: orgName
  };
};

var mapDispatchToProps = exports.mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return (0, _redux.bindActionCreators)({
    retrieveRepos: _repoActions.retrieveRepos,
    displayOrgs: _renderActions.displayOrgs
  }, dispatch);
};

exports.default = (0, _utils2.default)((0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(RepoList));